define('aim/capacity/view/NewFilterPopupView',['aim/capacity/view/AvailableResourcesView',
                                      'aim/capacity/view/FilteredResourcesView',
                                      'aim/capacity/view/AddResourcesButtonView',
                                      'aim/capacity/view/FilterPopupHeaderView',
                                      'aim/capacity/view/FilterPopupFooterView'], function(
                                    		  AvailableResourcesView,
                                    		  FilteredResourcesView,
                                    		  AddResourcesButtonView,
                                    		  FilterPopupHeaderView,
                                    		  FilterPopupFooterView) {
	var NewFilterPopupView = Backbone.View.extend({
	
		el: '#new-resource-filter-dialog',

	events: {
		"click #new-filter-cancel-button": "cancel",
		"click #new-filter-apply-button": "apply",
		"click #new-filter-save-button": "save",
		"click #new-filter-change-button": "change"
	},
	
	initialize: function() {
		var newFilterModel = this.model.get("newFilterModel");
		this.listenTo(newFilterModel, 'sync', this.render);
		var availableResourcesView = new AvailableResourcesView({model: newFilterModel});
		var filteredResourcesView = new FilteredResourcesView({model: newFilterModel});
		var addResourcesButtonView = new AddResourcesButtonView({model: newFilterModel});
		var filterPopupHeaderView = new FilterPopupHeaderView({model: newFilterModel});
		return this;
	},
		
	render: function() {
		var filterPopupFooterView = new FilterPopupFooterView({model: this.model.get("newFilterModel")});
		return this;
	},
	
	cancel: function(event) {
		AJS.dialog2("#new-resource-filter-dialog").hide();
	},
	
	apply: function(event) {
		if( this.model.get("newFilterModel").get("message") !== "" )return this;
		this.model.get("newFilterModel").set("operation","applyFilter");
		var that = this;
		this.model.get("newFilterModel").save(null, {success:function(model, res, options) {
			var result = res;
			if(res.message == ""){
				AJS.dialog2("#new-resource-filter-dialog").hide();
				that.model.get("filterContextModel").set("selectedFilter",result.filterId);
				that.model.get("filterContextModel").save();
				that.model.get("contextModel").set("selectedFilter",result.filterId);
				that.model.get("contextModel").set("resourceFilterChanged","true");
				that.model.get("contextModel").save();
				return this;
			}else{
				var message = that.model.get("newFilterModel").get("message");
				return this;
			}
		}});	
	},
	
	save: function(event) {
		if( this.model.get("newFilterModel").get("message") !== "" )return this;
		this.model.get("newFilterModel").set("operation","saveFilter");
		var that = this;
		this.model.get("newFilterModel").save(null, {success:function(model, res, options) {
			var result = res;
			if(res.message == ""){
				AJS.dialog2("#new-resource-filter-dialog").hide();
				that.model.get("filterContextModel").set("selectedFilter",result.filterId);
				that.model.get("filterContextModel").save();
				that.model.get("contextModel").set("selectedFilter",result.filterId);
				that.model.get("contextModel").set("resourceFilterChanged","true");
				that.model.get("contextModel").save();
				return this;
			}else{
				var message = that.model.get("newFilterModel").get("message");
				return this;
			}
		}});	
	},
	
	change: function(event) {
		if( this.model.get("newFilterModel").get("message") !== "" )return this;
		this.model.get("newFilterModel").set("operation","changeFilter");
		var that = this;
		this.model.get("newFilterModel").save(null, {success:function(model, res, options) {
			var result = res;
			if(res.message == ""){
				AJS.dialog2("#new-resource-filter-dialog").hide();
				that.model.get("filterContextModel").set("selectedFilter",result.filterId);
				that.model.get("filterContextModel").save();
				that.model.get("contextModel").set("selectedFilter",result.filterId);
				that.model.get("contextModel").set("resourceFilterChanged","true");
				that.model.get("contextModel").save();
				return this;
			}else{
				var message = that.model.get("newFilterModel").get("message");
				return this;
			}
		}});	
	}
});
	return NewFilterPopupView;
});